Index: structSensorMatrix.html
===================================================================
--- structSensorMatrix.html	(revision 1424)
+++ structSensorMatrix.html	(revision 1425)
@@ -1,10 +1,13 @@
-<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
-<html><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8">
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
 <title>libwireless: SensorMatrix Struct Reference</title>
-<link href="tabs.css" rel="stylesheet" type="text/css">
-<link href="doxygen.css" rel="stylesheet" type="text/css">
-</head><body>
-<!-- Generated by Doxygen 1.5.9 -->
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<link href="doxygen.css" rel="stylesheet" type="text/css"/>
+</head>
+<body>
+<!-- Generated by Doxygen 1.6.1 -->
 <div class="navigation" id="top">
   <div class="tabs">
     <ul>
@@ -22,79 +25,74 @@
   </div>
 </div>
 <div class="contents">
-<h1>SensorMatrix Struct Reference<br>
+<h1>SensorMatrix Struct Reference<br/>
 <small>
 [<a class="el" href="group__sensormatrix.html">Sensor Matrix</a>]</small>
-</h1><!-- doxytag: class="SensorMatrix" --><code>#include &lt;<a class="el" href="sensor__matrix_8h_source.html">sensor_matrix.h</a>&gt;</code>
-<p>
+</h1><!-- doxytag: class="SensorMatrix" -->
+<p><code>#include &lt;<a class="el" href="sensor__matrix_8h_source.html">sensor_matrix.h</a>&gt;</code></p>
 <table border="0" cellpadding="0" cellspacing="0">
-<tr><td></td></tr>
-<tr><td colspan="2"><br><h2>Data Fields</h2></td></tr>
-<tr><td class="memItemLeft" nowrap align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structSensorMatrix.html#888d68ace5ba04bfc741241718bc297c">numJoined</a></td></tr>
-
-<tr><td class="memItemLeft" nowrap align="right" valign="top">unsigned char&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structSensorMatrix.html#b2317919ee816e791633d4dc239f45af">joined</a> [MAXIMUM_XBEE_ID]</td></tr>
-
-<tr><td class="memItemLeft" nowrap align="right" valign="top">unsigned char&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structSensorMatrix.html#85a82252ddabc13c586cceb9b2819b62">matrix</a> [MAXIMUM_XBEE_ID][MAXIMUM_XBEE_ID]</td></tr>
-
+<tr><td colspan="2"><h2>Data Fields</h2></td></tr>
+<tr><td class="memItemLeft" align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structSensorMatrix.html#a888d68ace5ba04bfc741241718bc297c">numJoined</a></td></tr>
+<tr><td class="memItemLeft" align="right" valign="top">unsigned char&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structSensorMatrix.html#ab2317919ee816e791633d4dc239f45af">joined</a> [MAXIMUM_XBEE_ID]</td></tr>
+<tr><td class="memItemLeft" align="right" valign="top">unsigned char&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structSensorMatrix.html#a85a82252ddabc13c586cceb9b2819b62">matrix</a> [MAXIMUM_XBEE_ID][MAXIMUM_XBEE_ID]</td></tr>
 </table>
-<hr><a name="_details"></a><h2>Detailed Description</h2>
-A sensor matrix. <hr><h2>Field Documentation</h2>
-<a class="anchor" name="b2317919ee816e791633d4dc239f45af"></a><!-- doxytag: member="SensorMatrix::joined" ref="b2317919ee816e791633d4dc239f45af" args="[MAXIMUM_XBEE_ID]" -->
+<hr/><a name="_details"></a><h2>Detailed Description</h2>
+<p>A sensor matrix. </p>
+<hr/><h2>Field Documentation</h2>
+<a class="anchor" id="ab2317919ee816e791633d4dc239f45af"></a><!-- doxytag: member="SensorMatrix::joined" ref="ab2317919ee816e791633d4dc239f45af" args="[MAXIMUM_XBEE_ID]" -->
 <div class="memitem">
 <div class="memproto">
       <table class="memname">
         <tr>
-          <td class="memname">unsigned char <a class="el" href="structSensorMatrix.html#b2317919ee816e791633d4dc239f45af">SensorMatrix::joined</a>[MAXIMUM_XBEE_ID]          </td>
+          <td class="memname">unsigned char <a class="el" href="structSensorMatrix.html#ab2317919ee816e791633d4dc239f45af">SensorMatrix::joined</a>[MAXIMUM_XBEE_ID]</td>
         </tr>
       </table>
 </div>
 <div class="memdoc">
+<p>The element representing a robot is true if that robot is in the token ring and false otherwise. </p>
 
-<p>
-The element representing a robot is true if that robot is in the token ring and false otherwise. 
 <p>Referenced by <a class="el" href="sensor__matrix_8c_source.html#l00049">sensor_matrix_create()</a>, <a class="el" href="sensor__matrix_8c_source.html#l00134">sensor_matrix_get_in_ring()</a>, and <a class="el" href="sensor__matrix_8c_source.html#l00111">sensor_matrix_set_in_ring()</a>.</p>
 
 </div>
-</div><p>
-<a class="anchor" name="85a82252ddabc13c586cceb9b2819b62"></a><!-- doxytag: member="SensorMatrix::matrix" ref="85a82252ddabc13c586cceb9b2819b62" args="[MAXIMUM_XBEE_ID][MAXIMUM_XBEE_ID]" -->
+</div>
+<a class="anchor" id="a85a82252ddabc13c586cceb9b2819b62"></a><!-- doxytag: member="SensorMatrix::matrix" ref="a85a82252ddabc13c586cceb9b2819b62" args="[MAXIMUM_XBEE_ID][MAXIMUM_XBEE_ID]" -->
 <div class="memitem">
 <div class="memproto">
       <table class="memname">
         <tr>
-          <td class="memname">unsigned char <a class="el" href="structSensorMatrix.html#85a82252ddabc13c586cceb9b2819b62">SensorMatrix::matrix</a>[MAXIMUM_XBEE_ID][MAXIMUM_XBEE_ID]          </td>
+          <td class="memname">unsigned char <a class="el" href="structSensorMatrix.html#a85a82252ddabc13c586cceb9b2819b62">SensorMatrix::matrix</a>[MAXIMUM_XBEE_ID][MAXIMUM_XBEE_ID]</td>
         </tr>
       </table>
 </div>
 <div class="memdoc">
+<p>The matrix. Each row represents the readings of one robot. </p>
 
-<p>
-The matrix. Each row represents the readings of one robot. 
 <p>Referenced by <a class="el" href="sensor__matrix_8c_source.html#l00049">sensor_matrix_create()</a>, <a class="el" href="sensor__matrix_8c_source.html#l00093">sensor_matrix_get_reading()</a>, and <a class="el" href="sensor__matrix_8c_source.html#l00072">sensor_matrix_set_reading()</a>.</p>
 
 </div>
-</div><p>
-<a class="anchor" name="888d68ace5ba04bfc741241718bc297c"></a><!-- doxytag: member="SensorMatrix::numJoined" ref="888d68ace5ba04bfc741241718bc297c" args="" -->
+</div>
+<a class="anchor" id="a888d68ace5ba04bfc741241718bc297c"></a><!-- doxytag: member="SensorMatrix::numJoined" ref="a888d68ace5ba04bfc741241718bc297c" args="" -->
 <div class="memitem">
 <div class="memproto">
       <table class="memname">
         <tr>
-          <td class="memname">int <a class="el" href="structSensorMatrix.html#888d68ace5ba04bfc741241718bc297c">SensorMatrix::numJoined</a>          </td>
+          <td class="memname">int <a class="el" href="structSensorMatrix.html#a888d68ace5ba04bfc741241718bc297c">SensorMatrix::numJoined</a></td>
         </tr>
       </table>
 </div>
 <div class="memdoc">
+<p>The number of robots in the token ring. </p>
 
-<p>
-The number of robots in the token ring. 
 <p>Referenced by <a class="el" href="sensor__matrix_8c_source.html#l00049">sensor_matrix_create()</a>, <a class="el" href="sensor__matrix_8c_source.html#l00148">sensor_matrix_get_joined()</a>, and <a class="el" href="sensor__matrix_8c_source.html#l00111">sensor_matrix_set_in_ring()</a>.</p>
 
 </div>
-</div><p>
-<hr>The documentation for this struct was generated from the following file:<ul>
-<li><a class="el" href="sensor__matrix_8h_source.html">sensor_matrix.h</a></ul>
 </div>
-<hr size="1"><address style="text-align: right;"><small>Generated on Tue Sep 8 19:59:17 2009 for libwireless by&nbsp;
+<hr/>The documentation for this struct was generated from the following file:<ul>
+<li><a class="el" href="sensor__matrix_8h_source.html">sensor_matrix.h</a></li>
+</ul>
+</div>
+<hr size="1"/><address style="text-align: right;"><small>Generated on Sun Sep 20 12:12:02 2009 for libwireless by&nbsp;
 <a href="http://www.doxygen.org/index.html">
-<img src="doxygen.png" alt="doxygen" align="middle" border="0"></a> 1.5.9 </small></address>
+<img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.6.1 </small></address>
 </body>
 </html>