Index: wireless_8c.html
===================================================================
--- wireless_8c.html	(revision 1424)
+++ wireless_8c.html	(revision 1425)
@@ -1,10 +1,13 @@
-<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
-<html><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8">
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
 <title>libwireless: wireless.c File Reference</title>
-<link href="tabs.css" rel="stylesheet" type="text/css">
-<link href="doxygen.css" rel="stylesheet" type="text/css">
-</head><body>
-<!-- Generated by Doxygen 1.5.9 -->
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<link href="doxygen.css" rel="stylesheet" type="text/css"/>
+</head>
+<body>
+<!-- Generated by Doxygen 1.6.1 -->
 <div class="navigation" id="top">
   <div class="tabs">
     <ul>
@@ -22,78 +25,61 @@
   </div>
 </div>
 <div class="contents">
-<h1>wireless.c File Reference</h1>Wireless Library Implementation.  
-<a href="#_details">More...</a>
-<p>
-<code>#include &quot;<a class="el" href="wireless_8h_source.html">wireless.h</a>&quot;</code><br>
-<code>#include &quot;<a class="el" href="xbee_8h_source.html">xbee.h</a>&quot;</code><br>
-<code>#include &lt;stdlib.h&gt;</code><br>
-<code>#include &lt;stdio.h&gt;</code><br>
-<code>#include &quot;<a class="el" href="wl__defs_8h_source.html">wl_defs.h</a>&quot;</code><br>
-<code>#include &lt;sys/time.h&gt;</code><br>
-<code>#include &lt;signal.h&gt;</code><br>
+<h1>wireless.c File Reference</h1>
+<p>Wireless Library Implementation.  
+<a href="#_details">More...</a></p>
+<code>#include &quot;<a class="el" href="wireless_8h_source.html">wireless.h</a>&quot;</code><br/>
+<code>#include &quot;<a class="el" href="xbee_8h_source.html">xbee.h</a>&quot;</code><br/>
+<code>#include &lt;stdlib.h&gt;</code><br/>
+<code>#include &lt;stdio.h&gt;</code><br/>
+<code>#include &quot;<a class="el" href="wl__defs_8h_source.html">wl_defs.h</a>&quot;</code><br/>
+<code>#include &lt;sys/time.h&gt;</code><br/>
+<code>#include &lt;signal.h&gt;</code><br/>
 <table border="0" cellpadding="0" cellspacing="0">
-<tr><td></td></tr>
-<tr><td colspan="2"><br><h2>Functions</h2></td></tr>
-<tr><td class="memItemLeft" nowrap align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__wireless.html#gedd4562415e273ce6537f9c1a0f2701b">wl_init</a> ()</td></tr>
-
-<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Initialize the wireless library.  <a href="group__wireless.html#gedd4562415e273ce6537f9c1a0f2701b"></a><br></td></tr>
-<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__wireless.html#g66075ff87a1c9f2c0d7938a26c7830f2">wl_terminate</a> ()</td></tr>
-
-<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Uninitialize the wireless library.  <a href="group__wireless.html#g66075ff87a1c9f2c0d7938a26c7830f2"></a><br></td></tr>
-<tr><td class="memItemLeft" nowrap align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__wireless.html#g754445d2353a70963a489651cff554c1">wl_set_pan</a> (int pan)</td></tr>
-
-<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Set the PAN we are using.  <a href="group__wireless.html#g754445d2353a70963a489651cff554c1"></a><br></td></tr>
-<tr><td class="memItemLeft" nowrap align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__wireless.html#g4e6b5c97d40a8e7557a1b4b90a7d34f7">wl_get_pan</a> (void)</td></tr>
-
-<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Get the PAN we are using.  <a href="group__wireless.html#g4e6b5c97d40a8e7557a1b4b90a7d34f7"></a><br></td></tr>
-<tr><td class="memItemLeft" nowrap align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__wireless.html#g51d3fe958d44fd92f0e0830ced13139d">wl_set_channel</a> (int channel)</td></tr>
-
-<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Set the channel we are using.  <a href="group__wireless.html#g51d3fe958d44fd92f0e0830ced13139d"></a><br></td></tr>
-<tr><td class="memItemLeft" nowrap align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__wireless.html#g2d65d3e35b193da4213755c4bf61ab6b">wl_get_channel</a> (void)</td></tr>
-
-<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Get the channel we are using.  <a href="group__wireless.html#g2d65d3e35b193da4213755c4bf61ab6b"></a><br></td></tr>
-<tr><td class="memItemLeft" nowrap align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__wireless.html#g6c75a84ff5f9a2bdc156aba522d2adf7">wl_get_xbee_id</a> ()</td></tr>
-
-<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Get the 16-bit address of the XBee module.  <a href="group__wireless.html#g6c75a84ff5f9a2bdc156aba522d2adf7"></a><br></td></tr>
-<tr><td class="memItemLeft" nowrap align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__wireless.html#g6e841a6ef0504538d8650a0a2f5fa869">wl_send_robot_to_robot_global_packet</a> (char group, char type, char *data, int len, int dest, char frame)</td></tr>
-
-<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Send a packet to a specific robot in any PAN.  <a href="group__wireless.html#g6e841a6ef0504538d8650a0a2f5fa869"></a><br></td></tr>
-<tr><td class="memItemLeft" nowrap align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__wireless.html#gf8fbadf62eeb754b98b200328fb7a8be">wl_send_robot_to_robot_packet</a> (char group, char type, char *data, int len, int dest, char frame)</td></tr>
-
-<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Send a packet to a specific robot in our PAN.  <a href="group__wireless.html#gf8fbadf62eeb754b98b200328fb7a8be"></a><br></td></tr>
-<tr><td class="memItemLeft" nowrap align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__wireless.html#gda6b187ea58cee5aec18725bf7f24b9a">wl_send_global_packet</a> (char group, char type, char *data, int len, char frame)</td></tr>
-
-<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Send a packet to all robots.  <a href="group__wireless.html#gda6b187ea58cee5aec18725bf7f24b9a"></a><br></td></tr>
-<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__wireless.html#g0a1a0e4d885f0e0dde87160a16daa0aa">wl_send_pan_packet</a> (char group, char type, char *data, int len, char frame)</td></tr>
-
-<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Send a packet to all robots in our PAN.  <a href="group__wireless.html#g0a1a0e4d885f0e0dde87160a16daa0aa"></a><br></td></tr>
-<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__wireless.html#g183343ed0594ec1c2b79bb4085d57107">wl_register_packet_group</a> (<a class="el" href="structPacketGroupHandler.html">PacketGroupHandler</a> *h)</td></tr>
-
-<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Register a packet group with the wireless library.  <a href="group__wireless.html#g183343ed0594ec1c2b79bb4085d57107"></a><br></td></tr>
-<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__wireless.html#gcdbedf6465798abc7af3bf5fea3d4dd7">wl_unregister_packet_group</a> (<a class="el" href="structPacketGroupHandler.html">PacketGroupHandler</a> *h)</td></tr>
-
-<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Unregister a packet group with the wireless library.  <a href="group__wireless.html#gcdbedf6465798abc7af3bf5fea3d4dd7"></a><br></td></tr>
-<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__wireless.html#g5c1f1a0e20fc718e59edc29246afd703">wl_do</a> ()</td></tr>
-
-<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Perform wireless library functionality.  <a href="group__wireless.html#g5c1f1a0e20fc718e59edc29246afd703"></a><br></td></tr>
-<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="anchor" name="g344dead0023100eb40f8670a92c9ce5c"></a><!-- doxytag: member="wireless.c::wl_set_com_port" ref="g344dead0023100eb40f8670a92c9ce5c" args="(char *port)" -->
-void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__wireless.html#g344dead0023100eb40f8670a92c9ce5c">wl_set_com_port</a> (char *port)</td></tr>
-
-<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Set the com port on a computer, undefined on the robot. <br></td></tr>
+<tr><td colspan="2"><h2>Functions</h2></td></tr>
+<tr><td class="memItemLeft" align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__wireless.html#gaedd4562415e273ce6537f9c1a0f2701b">wl_init</a> ()</td></tr>
+<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Initialize the wireless library.  <a href="group__wireless.html#gaedd4562415e273ce6537f9c1a0f2701b"></a><br/></td></tr>
+<tr><td class="memItemLeft" align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__wireless.html#ga66075ff87a1c9f2c0d7938a26c7830f2">wl_terminate</a> ()</td></tr>
+<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Uninitialize the wireless library.  <a href="group__wireless.html#ga66075ff87a1c9f2c0d7938a26c7830f2"></a><br/></td></tr>
+<tr><td class="memItemLeft" align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__wireless.html#ga754445d2353a70963a489651cff554c1">wl_set_pan</a> (int pan)</td></tr>
+<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Set the PAN we are using.  <a href="group__wireless.html#ga754445d2353a70963a489651cff554c1"></a><br/></td></tr>
+<tr><td class="memItemLeft" align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__wireless.html#ga4e6b5c97d40a8e7557a1b4b90a7d34f7">wl_get_pan</a> (void)</td></tr>
+<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Get the PAN we are using.  <a href="group__wireless.html#ga4e6b5c97d40a8e7557a1b4b90a7d34f7"></a><br/></td></tr>
+<tr><td class="memItemLeft" align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__wireless.html#ga51d3fe958d44fd92f0e0830ced13139d">wl_set_channel</a> (int channel)</td></tr>
+<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Set the channel we are using.  <a href="group__wireless.html#ga51d3fe958d44fd92f0e0830ced13139d"></a><br/></td></tr>
+<tr><td class="memItemLeft" align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__wireless.html#ga2d65d3e35b193da4213755c4bf61ab6b">wl_get_channel</a> (void)</td></tr>
+<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Get the channel we are using.  <a href="group__wireless.html#ga2d65d3e35b193da4213755c4bf61ab6b"></a><br/></td></tr>
+<tr><td class="memItemLeft" align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__wireless.html#ga6c75a84ff5f9a2bdc156aba522d2adf7">wl_get_xbee_id</a> ()</td></tr>
+<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Get the 16-bit address of the XBee module.  <a href="group__wireless.html#ga6c75a84ff5f9a2bdc156aba522d2adf7"></a><br/></td></tr>
+<tr><td class="memItemLeft" align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__wireless.html#ga6e841a6ef0504538d8650a0a2f5fa869">wl_send_robot_to_robot_global_packet</a> (char group, char type, char *data, int len, int dest, char frame)</td></tr>
+<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Send a packet to a specific robot in any PAN.  <a href="group__wireless.html#ga6e841a6ef0504538d8650a0a2f5fa869"></a><br/></td></tr>
+<tr><td class="memItemLeft" align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__wireless.html#gaf8fbadf62eeb754b98b200328fb7a8be">wl_send_robot_to_robot_packet</a> (char group, char type, char *data, int len, int dest, char frame)</td></tr>
+<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Send a packet to a specific robot in our PAN.  <a href="group__wireless.html#gaf8fbadf62eeb754b98b200328fb7a8be"></a><br/></td></tr>
+<tr><td class="memItemLeft" align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__wireless.html#gada6b187ea58cee5aec18725bf7f24b9a">wl_send_global_packet</a> (char group, char type, char *data, int len, char frame)</td></tr>
+<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Send a packet to all robots.  <a href="group__wireless.html#gada6b187ea58cee5aec18725bf7f24b9a"></a><br/></td></tr>
+<tr><td class="memItemLeft" align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__wireless.html#ga0a1a0e4d885f0e0dde87160a16daa0aa">wl_send_pan_packet</a> (char group, char type, char *data, int len, char frame)</td></tr>
+<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Send a packet to all robots in our PAN.  <a href="group__wireless.html#ga0a1a0e4d885f0e0dde87160a16daa0aa"></a><br/></td></tr>
+<tr><td class="memItemLeft" align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__wireless.html#ga183343ed0594ec1c2b79bb4085d57107">wl_register_packet_group</a> (<a class="el" href="structPacketGroupHandler.html">PacketGroupHandler</a> *h)</td></tr>
+<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Register a packet group with the wireless library.  <a href="group__wireless.html#ga183343ed0594ec1c2b79bb4085d57107"></a><br/></td></tr>
+<tr><td class="memItemLeft" align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__wireless.html#gacdbedf6465798abc7af3bf5fea3d4dd7">wl_unregister_packet_group</a> (<a class="el" href="structPacketGroupHandler.html">PacketGroupHandler</a> *h)</td></tr>
+<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Unregister a packet group with the wireless library.  <a href="group__wireless.html#gacdbedf6465798abc7af3bf5fea3d4dd7"></a><br/></td></tr>
+<tr><td class="memItemLeft" align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__wireless.html#ga5c1f1a0e20fc718e59edc29246afd703">wl_do</a> ()</td></tr>
+<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Perform wireless library functionality.  <a href="group__wireless.html#ga5c1f1a0e20fc718e59edc29246afd703"></a><br/></td></tr>
+<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ga344dead0023100eb40f8670a92c9ce5c"></a><!-- doxytag: member="wireless.c::wl_set_com_port" ref="ga344dead0023100eb40f8670a92c9ce5c" args="(char *port)" -->
+void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__wireless.html#ga344dead0023100eb40f8670a92c9ce5c">wl_set_com_port</a> (char *port)</td></tr>
+<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Set the com port on a computer, undefined on the robot. <br/></td></tr>
 </table>
-<hr><h2>Detailed Description</h2>
-Wireless Library Implementation. 
-<p>
-Copyright (c) 2007 Colony Project<p>
-Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:<p>
-The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.<p>
-THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.<p>
-Implementation of the wireless library.<p>
-<dl class="author" compact><dt><b>Author:</b></dt><dd>Brian Coltin, Colony Project, CMU Robotics Club </dd></dl>
+<hr/><a name="_details"></a><h2>Detailed Description</h2>
+<p>Wireless Library Implementation. </p>
+<p>Copyright (c) 2007 Colony Project</p>
+<p>Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:</p>
+<p>The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.</p>
+<p>THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.</p>
+<p>Implementation of the wireless library.</p>
+<dl class="author"><dt><b>Author:</b></dt><dd>Brian Coltin, Colony Project, CMU Robotics Club </dd></dl>
 </div>
-<hr size="1"><address style="text-align: right;"><small>Generated on Tue Sep 8 19:59:17 2009 for libwireless by&nbsp;
+<hr size="1"/><address style="text-align: right;"><small>Generated on Sun Sep 20 12:12:02 2009 for libwireless by&nbsp;
 <a href="http://www.doxygen.org/index.html">
-<img src="doxygen.png" alt="doxygen" align="middle" border="0"></a> 1.5.9 </small></address>
+<img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.6.1 </small></address>
 </body>
 </html>