Index: wl__basic_8h.html
===================================================================
--- wl__basic_8h.html	(revision 1424)
+++ wl__basic_8h.html	(revision 1425)
@@ -1,10 +1,13 @@
-<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
-<html><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8">
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
 <title>libwireless: wl_basic.h File Reference</title>
-<link href="tabs.css" rel="stylesheet" type="text/css">
-<link href="doxygen.css" rel="stylesheet" type="text/css">
-</head><body>
-<!-- Generated by Doxygen 1.5.9 -->
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<link href="doxygen.css" rel="stylesheet" type="text/css"/>
+</head>
+<body>
+<!-- Generated by Doxygen 1.6.1 -->
 <div class="navigation" id="top">
   <div class="tabs">
     <ul>
@@ -22,62 +25,50 @@
   </div>
 </div>
 <div class="contents">
-<h1>wl_basic.h File Reference</h1>High Level Wireless Packet Sending-Receiving Functions.  
-<a href="#_details">More...</a>
-<p>
-<code>#include &lt;<a class="el" href="wireless_8h_source.html">wireless.h</a>&gt;</code><br>
+<h1>wl_basic.h File Reference</h1>
+<p>High Level Wireless Packet Sending-Receiving Functions.  
+<a href="#_details">More...</a></p>
+<code>#include &lt;<a class="el" href="wireless_8h_source.html">wireless.h</a>&gt;</code><br/>
 
-<p>
-<a href="wl__basic_8h_source.html">Go to the source code of this file.</a><table border="0" cellpadding="0" cellspacing="0">
-<tr><td></td></tr>
-<tr><td colspan="2"><br><h2>Data Structures</h2></td></tr>
-<tr><td class="memItemLeft" nowrap align="right" valign="top">struct &nbsp;</td><td class="memItemRight" valign="bottom"><b>PacketInfo</b></td></tr>
-
-<tr><td colspan="2"><br><h2>Defines</h2></td></tr>
-<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="anchor" name="g366b705160e22c2a6c4ea2c3c22e3485"></a><!-- doxytag: member="wl_basic.h::WL_BASIC_GROUP" ref="g366b705160e22c2a6c4ea2c3c22e3485" args="" -->
-#define&nbsp;</td><td class="memItemRight" valign="bottom"><b>WL_BASIC_GROUP</b>&nbsp;&nbsp;&nbsp;8</td></tr>
-
-<tr><td colspan="2"><br><h2>Functions</h2></td></tr>
-<tr><td class="memItemLeft" nowrap align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__wl__basic.html#gae4a8ae98cc33955ee20b6e481d47adf">wl_basic_init</a> (void(*handle_receive)(char type, int source, unsigned char *packet, int length))</td></tr>
-
-<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">init wireless for Basic Group  <a href="group__wl__basic.html#gae4a8ae98cc33955ee20b6e481d47adf"></a><br></td></tr>
-<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="anchor" name="ge482937c7c29521030a33ecbc5d2dd9d"></a><!-- doxytag: member="wl_basic.h::wl_basic_init_default" ref="ge482937c7c29521030a33ecbc5d2dd9d" args="(void)" -->
-int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__wl__basic.html#ge482937c7c29521030a33ecbc5d2dd9d">wl_basic_init_default</a> (void)</td></tr>
-
-<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">init wireless for Basic Group with default packet handling <br></td></tr>
-<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__wl__basic.html#gebc714e1bf382a98ac7a43762bf905c5">wl_basic_register_handler</a> (void(*handle_receive)(char type, int source, unsigned char *packet, int length))</td></tr>
-
-<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">internal function to register a packet handler function  <a href="group__wl__basic.html#gebc714e1bf382a98ac7a43762bf905c5"></a><br></td></tr>
-<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__wl__basic.html#gd5d7334484e49cc3cb9ebe2cfc323115">wl_basic_send_robot_packet</a> (char type, char *data, int len, int dest)</td></tr>
-
-<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">send a packet to a single robot in Basic Group  <a href="group__wl__basic.html#gd5d7334484e49cc3cb9ebe2cfc323115"></a><br></td></tr>
-<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__wl__basic.html#g72d4f604603ef2541b5f4d3ae467938e">wl_basic_send_global_packet</a> (char type, char *data, int len)</td></tr>
-
-<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">send a packet to all robots in Basic Group  <a href="group__wl__basic.html#g72d4f604603ef2541b5f4d3ae467938e"></a><br></td></tr>
-<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__wl__basic.html#g0ad976b2b61cca0081123606101c97cd">wl_basic_packet_receive_handler</a> (char type, int source, unsigned char *packet, int length)</td></tr>
-
-<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">default packet handler if none is specified on init  <a href="group__wl__basic.html#g0ad976b2b61cca0081123606101c97cd"></a><br></td></tr>
-<tr><td class="memItemLeft" nowrap align="right" valign="top">unsigned char *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__wl__basic.html#gae39ab95ba4a1b2ba2736f844c03cee7">wl_basic_do</a> (void)</td></tr>
-
-<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">wrapper for <a class="el" href="group__wireless.html#g5c1f1a0e20fc718e59edc29246afd703" title="Perform wireless library functionality.">wl_do()</a> to return packet data buffer  <a href="group__wl__basic.html#gae39ab95ba4a1b2ba2736f844c03cee7"></a><br></td></tr>
-<tr><td colspan="2"><br><h2>Variables</h2></td></tr>
-<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="anchor" name="gf0fa88111d706ef4e8b3bda5bc32596c"></a><!-- doxytag: member="wl_basic.h::wl_basic_group_handler" ref="gf0fa88111d706ef4e8b3bda5bc32596c" args="" -->
-<a class="el" href="structPacketGroupHandler.html">PacketGroupHandler</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__wl__basic.html#gf0fa88111d706ef4e8b3bda5bc32596c">wl_basic_group_handler</a></td></tr>
-
-<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight"><a class="el" href="structPacketGroupHandler.html">PacketGroupHandler</a> struct for Basic Group. <br></td></tr>
-<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="anchor" name="g6c9a887fb0b719948025f195efff1af9"></a><!-- doxytag: member="wl_basic.h::current_packet" ref="g6c9a887fb0b719948025f195efff1af9" args="" -->
-struct PacketInfo&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__wl__basic.html#g6c9a887fb0b719948025f195efff1af9">current_packet</a></td></tr>
-
-<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">current packet information, correct after <a class="el" href="group__wl__basic.html#gae39ab95ba4a1b2ba2736f844c03cee7" title="wrapper for wl_do() to return packet data buffer">wl_basic_do()</a> <br></td></tr>
+<p><a href="wl__basic_8h_source.html">Go to the source code of this file.</a></p>
+<table border="0" cellpadding="0" cellspacing="0">
+<tr><td colspan="2"><h2>Data Structures</h2></td></tr>
+<tr><td class="memItemLeft" align="right" valign="top">struct &nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structPacketInfo.html">PacketInfo</a></td></tr>
+<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">struct that contains relevant packet information  <a href="structPacketInfo.html#_details">More...</a><br/></td></tr>
+<tr><td colspan="2"><h2>Defines</h2></td></tr>
+<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ga366b705160e22c2a6c4ea2c3c22e3485"></a><!-- doxytag: member="wl_basic.h::WL_BASIC_GROUP" ref="ga366b705160e22c2a6c4ea2c3c22e3485" args="" -->
+#define&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__wl__basic.html#ga366b705160e22c2a6c4ea2c3c22e3485">WL_BASIC_GROUP</a>&nbsp;&nbsp;&nbsp;8</td></tr>
+<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">default wireless group for basic sending and receiving packets <br/></td></tr>
+<tr><td colspan="2"><h2>Functions</h2></td></tr>
+<tr><td class="memItemLeft" align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__wl__basic.html#gaae4a8ae98cc33955ee20b6e481d47adf">wl_basic_init</a> (void(*handle_receive)(char type, int source, unsigned char *packet, int length))</td></tr>
+<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">init wireless for Basic Group  <a href="group__wl__basic.html#gaae4a8ae98cc33955ee20b6e481d47adf"></a><br/></td></tr>
+<tr><td class="memItemLeft" align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__wl__basic.html#gae482937c7c29521030a33ecbc5d2dd9d">wl_basic_init_default</a> (void)</td></tr>
+<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">init wireless for Basic Group with default packet handling  <a href="group__wl__basic.html#gae482937c7c29521030a33ecbc5d2dd9d"></a><br/></td></tr>
+<tr><td class="memItemLeft" align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__wl__basic.html#gaebc714e1bf382a98ac7a43762bf905c5">wl_basic_register_handler</a> (void(*handle_receive)(char type, int source, unsigned char *packet, int length))</td></tr>
+<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">internal function to register a packet handler function  <a href="group__wl__basic.html#gaebc714e1bf382a98ac7a43762bf905c5"></a><br/></td></tr>
+<tr><td class="memItemLeft" align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__wl__basic.html#gad5d7334484e49cc3cb9ebe2cfc323115">wl_basic_send_robot_packet</a> (char type, char *data, int len, int dest)</td></tr>
+<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">send a packet to a single robot in Basic Group  <a href="group__wl__basic.html#gad5d7334484e49cc3cb9ebe2cfc323115"></a><br/></td></tr>
+<tr><td class="memItemLeft" align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__wl__basic.html#ga72d4f604603ef2541b5f4d3ae467938e">wl_basic_send_global_packet</a> (char type, char *data, int len)</td></tr>
+<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">send a packet to all robots in Basic Group  <a href="group__wl__basic.html#ga72d4f604603ef2541b5f4d3ae467938e"></a><br/></td></tr>
+<tr><td class="memItemLeft" align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__wl__basic.html#ga0ad976b2b61cca0081123606101c97cd">wl_basic_packet_receive_handler</a> (char type, int source, unsigned char *packet, int length)</td></tr>
+<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">internal default packet handler if none is specified on init  <a href="group__wl__basic.html#ga0ad976b2b61cca0081123606101c97cd"></a><br/></td></tr>
+<tr><td class="memItemLeft" align="right" valign="top">unsigned char *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__wl__basic.html#gad10a8456bc3d30d22fe1dbd40b6e0dbb">wl_basic_do_default</a> (void)</td></tr>
+<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">wrapper for <a class="el" href="group__wireless.html#ga5c1f1a0e20fc718e59edc29246afd703" title="Perform wireless library functionality.">wl_do()</a> to return packet data buffer  <a href="group__wl__basic.html#gad10a8456bc3d30d22fe1dbd40b6e0dbb"></a><br/></td></tr>
+<tr><td colspan="2"><h2>Variables</h2></td></tr>
+<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="gaf0fa88111d706ef4e8b3bda5bc32596c"></a><!-- doxytag: member="wl_basic.h::wl_basic_group_handler" ref="gaf0fa88111d706ef4e8b3bda5bc32596c" args="" -->
+<a class="el" href="structPacketGroupHandler.html">PacketGroupHandler</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__wl__basic.html#gaf0fa88111d706ef4e8b3bda5bc32596c">wl_basic_group_handler</a></td></tr>
+<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight"><a class="el" href="structPacketGroupHandler.html">PacketGroupHandler</a> struct for Basic Group. <br/></td></tr>
+<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ga6c9a887fb0b719948025f195efff1af9"></a><!-- doxytag: member="wl_basic.h::current_packet" ref="ga6c9a887fb0b719948025f195efff1af9" args="" -->
+struct <a class="el" href="structPacketInfo.html">PacketInfo</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__wl__basic.html#ga6c9a887fb0b719948025f195efff1af9">current_packet</a></td></tr>
+<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">current packet information, correct after wl_basic_do() <br/></td></tr>
 </table>
-<hr><h2>Detailed Description</h2>
-High Level Wireless Packet Sending-Receiving Functions. 
-<p>
-Abstracted wireless functionality for sending and receiving packets<p>
-<dl class="author" compact><dt><b>Author:</b></dt><dd>Christopher Mar, Colony Project, CMU Robotics Club </dd></dl>
+<hr/><a name="_details"></a><h2>Detailed Description</h2>
+<p>High Level Wireless Packet Sending-Receiving Functions. </p>
+<p>Abstracted wireless functionality for sending and receiving packets</p>
+<dl class="author"><dt><b>Author:</b></dt><dd>Christopher Mar, Colony Project, CMU Robotics Club </dd></dl>
 </div>
-<hr size="1"><address style="text-align: right;"><small>Generated on Tue Sep 8 19:59:17 2009 for libwireless by&nbsp;
+<hr size="1"/><address style="text-align: right;"><small>Generated on Sun Sep 20 12:12:02 2009 for libwireless by&nbsp;
 <a href="http://www.doxygen.org/index.html">
-<img src="doxygen.png" alt="doxygen" align="middle" border="0"></a> 1.5.9 </small></address>
+<img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.6.1 </small></address>
 </body>
 </html>