Index: branches/colonetmk2/code/lib/include/libwireless/wl_basic.h
===================================================================
--- branches/colonetmk2/code/lib/include/libwireless/wl_basic.h	(revision 1456)
+++ branches/colonetmk2/code/lib/include/libwireless/wl_basic.h	(revision 1457)
@@ -21,7 +21,7 @@
 #ifndef WL_BASIC_H
 #define WL_BASIC_H
 
-#include <wireless.h>
+#include "wireless.h"
 
 /** @brief default wireless group for basic sending and receiving packets **/
 #define WL_BASIC_GROUP 8
Index: branches/colonetmk2/code/lib/include/libdragonfly/dragonfly_lib.h
===================================================================
--- branches/colonetmk2/code/lib/include/libdragonfly/dragonfly_lib.h	(revision 1456)
+++ branches/colonetmk2/code/lib/include/libdragonfly/dragonfly_lib.h	(revision 1457)
@@ -75,8 +75,6 @@
 /** @} **/ //end addtogroup
 
 #include <inttypes.h>
-#include <stdio.h>
-#include <stdlib.h>
 #include <avr/io.h>
 #include <avr/interrupt.h>
 #include <util/delay.h>
@@ -86,21 +84,23 @@
 // missing from the AVR libc distribution.
 #include "atomic.h"
 
-#include <analog.h>
-#include <dio.h>
-#include <time.h>
-#include <lcd.h>
-#include <lights.h>
-#include <motor.h>
-#include <serial.h>
-#include <buzzer.h>
-#include <rangefinder.h>
-#include <bom.h>
-#include <encoders.h>
-#include <move.h>
-#include <reset.h>
-#include <math.h>
-#include <eeprom.h>
+#include "analog.h"
+#include "dio.h"
+#include "time.h"
+#include "lcd.h"
+#include "lights.h"
+#include "motor.h"
+#include "serial.h"
+#include "buzzer.h"
+#include "rangefinder.h"
+#include "bom.h"
+#include "encoders.h"
+#include "move.h"
+#include "reset.h"
+#include "math.h"
+#include "eeprom.h"
+
+#include <stddef.h>
 #include <stdbool.h>
 
 /** @brief shortcut for ATOMIC_BLOCK(ATOMIC_RESTORESTATE) **/
Index: branches/colonetmk2/code/lib/include/libdragonfly/bom.h
===================================================================
--- branches/colonetmk2/code/lib/include/libdragonfly/bom.h	(revision 1456)
+++ branches/colonetmk2/code/lib/include/libdragonfly/bom.h	(revision 1457)
@@ -68,6 +68,9 @@
 /** @brief Compares all the values in bom_val[] and returns the index to the highest value element. **/
 int bom_get_max(void);
 
+/** @brief Computes the weighted average of all the bom readings to estimate the position and distance of another robot. **/
+int bom_get_max10(int *dist);
+
 /** @brief Enables the selected bom leds on a BOM1.5 **/
 void bom_set_leds(int bit_field);
 
Index: branches/colonetmk2/code/lib/include/libdragonfly/i2c.h
===================================================================
--- branches/colonetmk2/code/lib/include/libdragonfly/i2c.h	(revision 1456)
+++ branches/colonetmk2/code/lib/include/libdragonfly/i2c.h	(revision 1457)
@@ -36,8 +36,6 @@
 #ifndef _I2C_H_
 #define _I2C_H_
 
-#include <stddef.h>
-
 /** @brief Address of slave receive handler function **/
 typedef void (*fun_srecv_t)(char);
 
@@ -48,7 +46,7 @@
 typedef char (*fun_send_t)(void);
 
 int i2c_init(char addr, fun_mrecv_t master_recv, fun_srecv_t slave_recv, fun_send_t slave_send);
-int i2c_send(char dest, char* data, size_t bytes);
+int i2c_send(char dest, char* data, unsigned int bytes);
 int i2c_request(char dest);
 
 void i2c_packet_rec (char i2c_byte);
Index: branches/colonetmk2/code/lib/include/libdragonfly/eeprom.h
===================================================================
--- branches/colonetmk2/code/lib/include/libdragonfly/eeprom.h	(revision 1456)
+++ branches/colonetmk2/code/lib/include/libdragonfly/eeprom.h	(revision 1457)
@@ -10,8 +10,6 @@
  #ifndef _EEPROM_H_
  #define _EEPROM_H_
  
- #include <bom.h>
- 
  #define EEPROM_ROBOT_ID_ADDR 0x10
  #define EEPROM_BOM_TYPE_ADDR 0x14
  
Index: branches/colonetmk2/code/lib/bin/libwireless.a
===================================================================
Cannot display: file marked as a binary type.
svn:mime-type = application/octet-stream
Index: branches/colonetmk2/code/lib/bin/libdragonfly.a
===================================================================
Cannot display: file marked as a binary type.
svn:mime-type = application/octet-stream